{
  description = "Hallo Nix Flakes";

  inputs = {
    utils.url = "github:numtide/flake-utils";
    naersk.url = "github:nix-community/naersk";
    src.url = "path:..";
    src.flake = false;
  };

  outputs = { self, nixpkgs, utils, naersk, src }:
    utils.lib.eachDefaultSystem (system: let
      pkgs = nixpkgs.legacyPackages."${system}";
      naersk-lib = naersk.lib."${system}";
    in rec {
      # `nix build`
      packages.hallo = naersk-lib.buildPackage {
        pname = "hallo";
        #root = ./..;
        root = src;
      };

      defaultPackage = packages.hallo;

      # NixOS Modules
      nixosModules = {
        halloSvc = import ./modules/halloSvc.nix self;
      };

      # `nix run`
      apps.hallo = utils.lib.mkApp {
        drv = packages.hallo;
      };
      defaultApp = apps.hallo;

      # `nix develop`
      devShell = pkgs.mkShell {
        nativeBuildInputs = with pkgs; [ rustc cargo ];
      };
    });
}
