flake: {config, pkgs, lib, hallo, ...}:

let
  cfg = config.services.halloSvc;
  inherit (flake.packages.${pkgs.stdenv.hostPlatform.system}) hallo;
in

with lib;
# builtins.trace ''hallo zzz: blar ${builtins.attrNames hallo.packages}''
{
  options = {
    services.halloSvc = {
      enable = mkOption {
        default = false;
        type = with types; bool;
        description = ''
          Start the hallo service
        '';
      };

      user = mkOption {
        default = "hallo";
        type = with types; uniq string;
        description = ''
          Name of the user.
        '';
      };
    };
  };

  config = mkIf cfg.enable {
    users.users."${cfg.user}" = {
      description = "Hallo daemon user";
      isSystemUser = true;
      group = "${cfg.user}";
    };
    users.groups."${cfg.user}" = {};

    systemd.services.halloSvc = {
      wantedBy = [ "multi-user.target" ];
      after = [ "network.target" ];
      description = "Start the halloSvc.";
      serviceConfig = {
        Type = "simple";
        User = "${cfg.user}";
        ExecStart = ''${hallo}/bin/hallo'';
      };
    };
  };
}
